var canvas;
var cntx;

function init(){
    canvas=document.getElementById("visualisation");
    cntx=canvas.getContext("2d");
    
    showAppTitle();
    initialValues();
    initialiseGUI();
    initialiseEvents();
    drawBasicScreen();
}
      
function initialiseEvents(){
    $("#visualisation").on("mousemove",function(evt){
        var rect=canvas.getBoundingClientRect();
        mx=evt.clientX-rect.left;
        my=evt.clientY-rect.top;
        handleMouseMove();
    });

    $("#visualisation").on("mouseup",function(evt){
        evt.preventDefault();
        evt.stopPropagation();
        var rect=canvas.getBoundingClientRect();
        mx=evt.clientX-rect.left;
        my=evt.clientY-rect.top;
        handleMouseUp();
        mouseButtonPressed=noMouseButtonPressed;
    });

    $("#visualisation").on("mousedown",function(evt){
        var rect=canvas.getBoundingClientRect();
        mx=evt.clientX-rect.left;
        my=evt.clientY-rect.top;
        mouseButtonPressed=evt.button;
        handleMouseDown();
    });

    $(document).contextmenu(function(){
        return false;
    });
    
    window.addEventListener("beforeunload",function(e){
    	resetSimulation();
    });
}

function initialiseGUI(){
    initialisePalette();
	initialiseShapeLib();
	initialiseExamples();
}

function initialValues(){
    TitleTOP=20;
    TitleWIDTH=550;
    TitleLEFT=(width-TitleWIDTH)/2;
    TitleHEIGHT=35;
    imgLogo=document.getElementById("Logo");
    width=canvas.width;
    height=canvas.height;

    BottomPanelTop=height-BottomPanelHeight;
    logoLeft=width-logoWidth-5;
    logoTop=BottomPanelTop+(BottomPanelHeight-logoHeight)/2;
    imgNxtStepEnabled=document.getElementById("ButtonEnabledSmall");
    imgNxtStepSelected=document.getElementById("ButtonSelSmall");
    imgBackStepEnabled=document.getElementById("BackEnabledSmall");
    imgBackStepSelected=document.getElementById("BackSelSmall");
    nxtStepLeft=width-nxtStepWidth-15-logoWidth;
    nxtStepTop=BottomPanelTop+30;
    BackStepLeft=2;
    BackStepTop=nxtStepTop;
    
    $("#HscrAngle").val(0);
}

function drawBasicScreen(){
    cntx.clearRect(0,0,canvas.width,canvas.height);
    //Φόντα οθόνης
    drawIntroImage();
    if(introStep>=introLastStep){
        drawExample();
        drawLibrary();
    }
    drawPanels();
    drawLogoImage();
    if(introStep==introLastStep){
        $("#controlsDIV").show();
        /*if(my>=TopPanelHeight && my<=BottomPanelTop){
            cnvsWrite(LetterColor,coordsFontSize,"Arial",600,TopPanelHeight+coordsFontSize,"x="+mx+" , y="+(my-TopPanelHeight));
        }*/
    }
    else{
        $("#controlsDIV").hide();
    }
    showUserPrompts();
}

function drawIntroImage(){
    if(introStep<introLastStep){
        Intro=document.getElementById("img"+introStep);
    }
    else{
        Intro=document.getElementById("img1");
    }
    picTop=(height-Intro.height)/2;

    if(introStep<introLastStep){
        cntx.drawImage(Intro,1,picTop);
    }
    else{
        cntx.fillStyle="rgb(255,255,255)";
        cntx.beginPath();
        cntx.fillRect(1,picTop,width-2,Intro.height);
    }
}

function drawPanels(){
    var lowRectTop=picTop+Intro.height+1;
    cntx.clearRect(0,0,width,picTop-1);
    cntx.clearRect(0,lowRectTop,width,height-lowRectTop);
    cntx.strokeStyle="black";
    cntx.beginPath();
    //πλαίσιο καμβά
    cntx.rect(0,0,width,height);
    //άνω πλαίσιο
    cntx.rect(0,0,width,picTop-1);
    //κάτω πλαίσιο
    cntx.rect(0,lowRectTop,width,height-lowRectTop);
    cntx.stroke();
    cnvsWrite(LetterColor,35,"Arial",-1,TitleTOP+TitleHEIGHT,appTitle);
    if(introStep<introLastStep) drawButtonNext();
    if(introStep>1) drawButtonBack();
}

function drawLogoImage(){
    var picTop=(height-Intro.height)/2;
    var lowRectTop=picTop+Intro.height+5;
    var logoTop=lowRectTop+((height-lowRectTop)-imgLogo.height)/2;
    cntx.drawImage(imgLogo,width-imgLogo.width-2,logoTop);
}

function showHTML(){
    window.open("index_DS_I_DS_II.html","_blank");
}

function drawButtonNext(){
    //Διαχείριση κουμπιού [Επόμενο Βήμα]
    if (buttonNextHover()){
        cntx.drawImage(imgNxtStepSelected,nxtStepLeft,nxtStepTop);
    }
    else{
        cntx.drawImage(imgNxtStepEnabled,nxtStepLeft,nxtStepTop);
    }
}

function buttonNextHover(){
    if (mx>=nxtStepLeft && mx<=nxtStepLeft+nxtStepWidth && my>=nxtStepTop && my<=nxtStepTop+nxtStepHeight){
        return true;
    }
    else {
        return false;
    }
}

function drawButtonBack(){
    //Διαχείριση κουμπιού [Επόμενο Βήμα]
    if (buttonBackHover()){
        cntx.drawImage(imgBackStepSelected,BackStepLeft,BackStepTop);
    }
    else{
        cntx.drawImage(imgBackStepEnabled,BackStepLeft,BackStepTop);
    }
}

function buttonBackHover(){
    if (mx>=BackStepLeft && mx<=BackStepLeft+BackStepWidth && my>=BackStepTop && my<=BackStepTop+BackStepHeight){
        return true;
    }
    else {
        return false;
    }
}

function cnvsWrite(clr,fontSize,fontName,txtX,txtY,txt){       
    cntx.font=fontSize+"px "+fontName;
    cntx.fillStyle=clr;
    if(txtX<0) txtX=(canvas.width-cntx.measureText(txt).width)/2;
    cntx.fillText(txt,txtX,txtY);
}

function handleMouseDown(){
	if(introStep==introLastStep){
		if(my>TopPanelHeight && my<BottomPanelTop && shapeHover>-1){
			canvas.style.cursor="pointer";
			draggingShape=true;
			shapeToDrag=shapeHover;
			dDragX=mx-libShape[shapeToDrag][0];
			dDragY=my-libShape[shapeToDrag][1];
			$("#HscrAngle").val(libShape[shapeToDrag][11]);
			rangeValueChanged("HscrAngle");
		}
		else{
			shapeToDrag=-1;
		}
	}
	
    drawBasicScreen();
}

function handleMouseMove(){
    if(mx>=logoLeft && mx<logoLeft+logoWidth && my>=logoTop && my<logoTop+logoHeight){
        imgLogo=document.getElementById("LogoSel");
    }
    else{
        imgLogo=document.getElementById("Logo");
    }
    if(introStep>=introLastStep){
    	if(mouseButtonPressed==leftMouseButtonPressed){
    		if(shapeToDrag>-1){ //Move						
    			libShape[shapeToDrag][0]=mx-dDragX;
    			libShape[shapeToDrag][1]=my-dDragY;				
    		}
    	}
    	else{
            canvas.style.cursor="default";
    		checkShapeHover();
    		if(shapeHover>-1){
    	        canvas.style.cursor="pointer";
    		}
    	}
    }
    if(!solving) drawBasicScreen();
}

function handleMouseUp(){
	draggingShape=false;
    if(mx>=logoLeft && mx<logoLeft+logoWidth && my >=logoTop && my<logoTop+logoHeight){
        showHTML();
    }
    if(mx>=nxtStepLeft && mx<nxtStepLeft+nxtStepWidth && my>=nxtStepTop && my<nxtStepTop+nxtStepHeight && introStep<introLastStep){
        introStep++;
		currentShape=-1;
		solving=false;
		initialiseShapeLib();
		selectExample();
    }
    if(mx>=BackStepLeft && mx<BackStepLeft+BackStepWidth && my>=BackStepTop && my<BackStepTop+BackStepHeight && introStep>1){
        introStep--;
    }
    drawBasicScreen();
}

function showUserPrompts(){
    var vTxtOffset=15;
    var hTxtOffset=BackStepLeft+BackStepWidth+border;
    var promptYCoord;
    if(introStep==introLastStep){
        promptYCoord=BottomPanelTop+43;
        cnvsWrite(LetterColor,fontSize,"Arial",hTxtOffset,promptYCoord,"Χρησιμοποίησε το ποντίκι για να διαλέξεις ένα από τα επτά κομμάτια και να το μετακινήσεις.");
        promptYCoord=promptYCoord+vTxtOffset;
        cnvsWrite(LetterColor,fontSize,"Arial",hTxtOffset,promptYCoord,"Με τη μπάρα κύλισης μπορείς να περιστρέψεις το σχήμα που διάλεξες. Δίπλα από αυτή βλέπεις τη γωνία σε μοίρες.");
        promptYCoord=promptYCoord+vTxtOffset;
        cnvsWrite(LetterColor,fontSize,"Arial",hTxtOffset,promptYCoord,"Προσπάθησε να τακτοποιήσεις τα σχήματα ώστε να δημιουργηθεί το περίγραμμα που βλέπεις.");
    }
}

function initialisePalette(){
    paletteR[0]=0; paletteG[0]=0; paletteB[0]=0;
    paletteR[1]=90; paletteG[1]=90; paletteB[1]=90;
    paletteR[2]=255; paletteG[2]=0; paletteB[2]=0;
    paletteR[3]=0; paletteG[3]=255; paletteB[3]=0;
    paletteR[4]=0; paletteG[4]=0; paletteB[4]=255;
    paletteR[5]=130; paletteG[5]=0; paletteB[5]=100;
    paletteR[6]=240; paletteG[6]=140; paletteB[6]=70;
    paletteR[7]=240; paletteG[7]=80; paletteB[7]=70;
    paletteR[8]=160; paletteG[8]=45; paletteB[8]=170;
    paletteR[9]=160; paletteG[9]=45; paletteB[9]=225;
    paletteR[10]=100; paletteG[10]=60; paletteB[10]=200;
    paletteR[11]=60; paletteG[11]=130; paletteB[11]=200;
    paletteR[12]=60; paletteG[12]=175; paletteB[12]=200;
    paletteR[13]=160; paletteG[13]=175; paletteB[13]=220;
    paletteR[14]=210; paletteG[14]=180; paletteB[14]=150;
    paletteR[15]=255; paletteG[15]=255; paletteB[15]=0;
}

function actionPerformed(btnSlctr){
    if(btnSlctr=="btnRestart"){
		hideSolution();
		initialiseShapeLib();
		$("#chkSameColors").prop("checked",true);
		solving=false;
		$("#chkDifficult").prop("disabled",false);
    }
    else if(btnSlctr=="btnNewGame"){
		initialiseShapeLib();
		hideSolution();
		selectExample();
    }
    else if(btnSlctr=="btnSolution"){
		if($("#chkDifficult").prop("checked")){
			showSolution();
		}
		else{
			hideSolution();
			$("#btnRestart").prop("disabled",true);
			$("#btnNewGame").prop("disabled",true);
			$("#btnSolution").prop("disabled",true);

			//initialiseShapeLib();
			$("#chkDifficult").prop("disabled",true);
			$("#chkSameColors").prop("checked",false);
			$("#chkSameColors").prop("disabled",true);
			
			for(var i=0;i<noOfShapes;i++){
				dX[i]=(libShapeEx[i][0]-libShape[i][0])/(noOfSolutionSteps-1);
				dY[i]=(libShapeEx[i][1]-libShape[i][1])/(noOfSolutionSteps-1);
				dTheta[i]=(libShapeEx[i][11]-libShape[i][11])/(noOfSolutionSteps-1);
			}
			setDifferentColors();
			initialiseSimulation();
		}
    }
    shapeToDrag=-1;
    drawBasicScreen();
}

function showSolution(){
	for(var i=0;i<7;i++){
		libShapeEx[i][12]=i+1;
	}
	drawBasicScreen();
}

function hideSolution(){
	for(var i=0;i<7;i++){
		libShapeEx[i][12]=0;
	}		
}

function roundRect(x,y,width,height,radius,fill,stroke){
    if(typeof stroke=="undefined"){
        stroke=true;
    }
    if(typeof radius==="undefined"){
        radius=5;
    }
    if (typeof radius==="number"){
        radius={tl: radius, tr: radius, br: radius, bl: radius};
    }
    else{
        var defaultRadius={tl:0, tr:0, br:0, bl:0};
        for(var side in defaultRadius){
            radius[side]=radius[side] || defaultRadius[side];
        }
    }
    cntx.beginPath();
    cntx.moveTo(x+radius.tl,y);
    cntx.lineTo(x+width-radius.tr,y);
    cntx.quadraticCurveTo(x+width,y,x+width,y+radius.tr);
    cntx.lineTo(x+width,y+height-radius.br);
    cntx.quadraticCurveTo(x+width,y+height,x+width-radius.br,y+height);
    cntx.lineTo(x+radius.bl,y+height);
    cntx.quadraticCurveTo(x,y+height,x,y+height-radius.bl);
    cntx.lineTo(x,y+radius.tl);
    cntx.quadraticCurveTo(x,y,x+radius.tl,y);
    cntx.closePath();
    if(fill){
      cntx.fill();
    }
    if(stroke){
      cntx.stroke();
    }
  }

function itemStateChanged(slctr){
    if(slctr=="chkSameColors"){
		if($("#chkSameColors").prop("checked")){
			for(var i=0;i<7;i++){
				libShape[i][12]=11;
			}
		}
		else{
			setDifferentColors();
		}			
    }
    else if(slctr=="chkDifficult"){
		if($("#chkDifficult").prop("checked")){
			zoomFactor=0.8;
		}
		else{
			zoomFactor=1;
		}
		initialiseShapeLib();
    }
    drawBasicScreen();
}

function setDifferentColors(){
	var i,colIndx;
	var colorUsed=[];
	for(i=0;i<noOfPaletteColors;i++){
		colorUsed.push(false);
	}
	for(i=0;i<noOfShapes;i++){
		do{			
			colIndx=parseInt(Math.random()*(noOfPaletteColors-1))+1;
		}while(colorUsed[colIndx]);
		colorUsed[colIndx]=true;
		libShape[i][12]=colIndx;
	}
}

function initialiseSimulation(){
	currentSolutionStep=0;
    solving=true;
    timerLoop=setInterval(function(){run();},simulationSpeed);	
}

function resetSimulation(){
	clearInterval(timerLoop);
	solving=false;
	$("#chkDifficult").prop("disabled",false);
	$("#chkSameColors").prop("disabled",false);
	$("#btnRestart").prop("disabled",false);
	$("#btnNewGame").prop("disabled",false);
	$("#btnSolution").prop("disabled",false);
}

function rangeValueChanged(slctr){
    if(slctr=="HscrAngle" && shapeToDrag>-1){
        $("#lblAngle").text(parseInt($("#HscrAngle").val()));
		libShape[shapeToDrag][11]=parseInt($("#HscrAngle").val());
    }
    if(!solving) drawBasicScreen();
}

function checkShapeHover(){
	var i=noOfShapes-1;
	var shp=-1;
	while(i>-1 && shp==-1){
		if(shpHover(i)) shp=i;
		i--;
	}
	shapeHover=shp;
}

function shpHover(i){
	var flag=false;
	var angle=-libShape[i][11]*Math.PI/180;
	var a,b;
	var origMx,origMy,testY;
	//Μεταφορά ίχνους ποντικιού στην αρχή του συστήματος αναφοράς
	origMx=parseInt(Math.cos(angle)*(mx-libShape[i][0])-Math.sin(angle)*(my-libShape[i][1]));
	origMy=parseInt(Math.sin(angle)*(mx-libShape[i][0])+Math.cos(angle)*(my-libShape[i][1]));
	
	if(i==5){ //τετράγωνο
		if(origMx>libShape[i][2] && origMx<libShape[i][8] && origMy>libShape[i][3] && origMy<libShape[i][5]){
			flag=true;
		}
	}
	else if(i==6){ //πλάγιο παραλληλόγραμμο
		if(libShape[i][2]<origMx && origMx<libShape[i][4]){ //Αριστερό τρίγωνο
			a=(libShape[i][5]-libShape[i][3])/(libShape[i][4]-libShape[i][2]);
			b=libShape[i][5]-a*libShape[i][4];
			testY=parseInt(a*origMx+b);
			if(libShape[i][3]<origMy && origMy<testY) {
				flag=true;
			}
		}
		else if(libShape[i][4]<origMx && origMx<libShape[i][8]){ //Κεντρικό τετράγωνο
			if(libShape[i][3]<origMy && origMy<libShape[i][5]){
				flag=true;
			}
		}
		else if(libShape[i][8]<origMx && origMx<libShape[i][6]){ //Δεξί τρίγωνο
			a=(libShape[i][7]-libShape[i][9])/(libShape[i][6]-libShape[i][8]);
			b=(libShape[i][7])-a*(libShape[i][6]);
			testY=parseInt(a*origMx+b);
			if(testY<origMy && origMy<libShape[i][7]) {
				flag=true;
			}
		}
	}
	else{ //τρίγωνα
		a=(libShape[i][7]-libShape[i][5])/(libShape[i][6]-libShape[i][4]);
		b=libShape[i][5]-a*libShape[i][4];
		testY=parseInt(a*origMx+b);
		if(libShape[i][2]<origMx && libShape[i][6]>origMx && origMy<testY && libShape[i][3]<origMy) {
			flag=true;
		}
	}
	return flag;
}

function run(){
	if(solving){
		currentSolutionStep++;
		if(currentSolutionStep==noOfSolutionSteps){
			for(var i=0;i<noOfShapes;i++){
				libShape[i][0]=libShapeEx[i][0];
				libShape[i][1]=libShapeEx[i][1];
				libShape[i][11]=libShapeEx[i][11];
			}
			resetSimulation();
		}
		else{
			for(var i=0;i<noOfShapes;i++){
				if(libShape[i][0]!=libShapeEx[i][0]){
					libShape[i][0]+=dX[i];
				}
				if(libShape[i][1]!=libShapeEx[i][1]){
					libShape[i][1]+=dY[i];
				}
				if(libShape[i][11]!=libShapeEx[i][11]){
					libShape[i][11]+=dTheta[i];
				}
			}
		}
		drawBasicScreen();
	}
}

function drawExample(){
    for(var i=0;i<noOfShapes;i++){
        drawShapeEx(i);
    }
}

function fillPolygon(x,y,n){
	cntx.beginPath();
	cntx.moveTo(x[n-1],y[n-1]);
	for(var i=0;i<n;i++){
		cntx.lineTo(x[i],y[i]);
	}
	cntx.closePath();
	cntx.fill();
}

function drawShapeEx(i){
    var r,g,b,paletteIndex;
    var xx=[0,0,0,0];
    var yy=[0,0,0,0];
    xx=onScreenEx(i,1);
    yy=onScreenEx(i,2);
    paletteIndex=libShapeEx[i][12];
    r=paletteR[paletteIndex];           
    g=paletteG[paletteIndex];           
    b=paletteB[paletteIndex];
    cntx.fillStyle="rgb("+r+","+g+","+b+")";
    fillPolygon(xx,yy,libShapeEx[i][pointsNoIndx]);
}

function onScreenEx(iShp,coordSelected){
    var angle=libShapeEx[iShp][11]*Math.PI/180;
    var currentX,currentY;
    var xx=[0,0,0,0];
    var yy=[0,0,0,0];
    for(var j=0;j<libShapeEx[iShp][pointsNoIndx];j++){
        currentX=libShapeEx[iShp][2*(j+1)];
        currentY=libShapeEx[iShp][2*(j+1)+1];
        xx[j]=Math.cos(angle)*currentX-Math.sin(angle)*currentY+libShapeEx[iShp][0];
        yy[j]=Math.sin(angle)*currentX+Math.cos(angle)*currentY+libShapeEx[iShp][1];
    }
    if(coordSelected==1){
        return xx;
    }
    else{
        return yy;
    }
}


function drawLibrary(){
    for(var i=0;i<noOfShapes;i++){
        if(i!=shapeToDrag) drawShape(i);
    }
    if(shapeToDrag>-1) drawShape(shapeToDrag);
}

function drawShape(i){
    var r,g,b,paletteIndex;
    var xx=[0,0,0,0];
    var yy=[0,0,0,0];
    xx=onScreen(i,1);
    yy=onScreen(i,2);
    if(shapeToDrag==i){
        paletteIndex=(libShape[i][12]+1) % noOfPaletteColors;
    }
    else{
        paletteIndex=libShape[i][12];
    }
    r=paletteR[paletteIndex];           
    g=paletteG[paletteIndex];           
    b=paletteB[paletteIndex];
    cntx.fillStyle="rgb("+r+","+g+","+b+")";
    fillPolygon(xx,yy,libShape[i][pointsNoIndx]);
}

function onScreen(iShp,coordSelected){
    var angle=libShape[iShp][11]*Math.PI/180;
    var currentX,currentY;
    var xx=[0,0,0,0];
    var yy=[0,0,0,0];
    for(var j=0;j<libShape[iShp][pointsNoIndx];j++){
        currentX=libShape[iShp][2*(j+1)];
        currentY=libShape[iShp][2*(j+1)+1];
        xx[j]=Math.cos(angle)*currentX-Math.sin(angle)*currentY+libShape[iShp][0];
        yy[j]=Math.sin(angle)*currentX+Math.cos(angle)*currentY+libShape[iShp][1];
    }
    if(coordSelected==1){
        return xx;
    }
    else{
        return yy;
    }
}

function SwapShapes(i,j){
	var temp,k;
	for(k=0;k<13;k++){
		temp=libShape[i][k];
		libShape[i][k]=libShape[j][k];
		libShape[j][k]=temp;
	}
}

function initialiseShapeLib(){
	var i=0;
	var BSize=parseInt(baseSize*zoomFactor);
	//1ο Μεγάλο
	libShape[i][0]=10+2*BSize*i;
	libShape[i][1]=TopPanelHeight+20;
	libShape[i][2]=0;
	libShape[i][3]=0;
	libShape[i][4]=0;
	libShape[i][5]=2*BSize;
	libShape[i][6]=2*BSize;
	libShape[i][7]=0;
	libShape[i][8]=0;
	libShape[i][9]=9;
	libShape[i][10]=3;
	libShape[i][11]=0;
	libShape[i][12]=11;
	//2ο Μεγάλο
	i=1;
	libShape[i][0]=libShape[i-1][0]+2*BSize;
	libShape[i][1]=TopPanelHeight+20;
	libShape[i][2]=0;
	libShape[i][3]=0;
	libShape[i][4]=0;
	libShape[i][5]=2*BSize;
	libShape[i][6]=2*BSize;
	libShape[i][7]=0;
	libShape[i][8]=0;
	libShape[i][9]=9;
	libShape[i][10]=3;
	libShape[i][11]=0;
	libShape[i][12]=11;
	//Μεσαίο
	i=2;
	libShape[i][0]=libShape[i-1][0]+2*BSize;
	libShape[i][1]=TopPanelHeight+20;
	libShape[i][2]=0;
	libShape[i][3]=0;
	libShape[i][4]=0;
	libShape[i][5]=parseInt(BSize*Math.sqrt(2));
	libShape[i][6]=parseInt(BSize*Math.sqrt(2));
	libShape[i][7]=0;
	libShape[i][8]=0;
	libShape[i][9]=9;
	libShape[i][10]=3;
	libShape[i][11]=0;
	libShape[i][12]=11;
	//1ο Μικρό
	i=3;
	libShape[i][0]=libShape[i-1][0]+3*BSize/2;
	libShape[i][1]=TopPanelHeight+20;
	libShape[i][2]=0;
	libShape[i][3]=0;
	libShape[i][4]=0;
	libShape[i][5]=BSize;
	libShape[i][6]=BSize;
	libShape[i][7]=0;
	libShape[i][8]=0;
	libShape[i][9]=9;
	libShape[i][10]=3;
	libShape[i][11]=0;
	libShape[i][12]=11;
	//2ο Μικρό
	i=4;
	libShape[i][0]=libShape[i-1][0]+BSize;
	libShape[i][1]=TopPanelHeight+20;
	libShape[i][2]=0;
	libShape[i][3]=0;
	libShape[i][4]=0;
	libShape[i][5]=BSize;
	libShape[i][6]=BSize;
	libShape[i][7]=0;
	libShape[i][8]=0;
	libShape[i][9]=9;
	libShape[i][10]=3;
	libShape[i][11]=0;
	libShape[i][12]=11;
	//Τετράγωνο
	i=5;
	libShape[i][0]=libShape[i-1][0]+BSize;
	libShape[i][1]=TopPanelHeight+20;
	libShape[i][2]=0;
	libShape[i][3]=0;
	libShape[i][4]=0;
	libShape[i][5]=BSize;
	libShape[i][6]=BSize;
	libShape[i][7]=BSize;
	libShape[i][8]=BSize;
	libShape[i][9]=0;
	libShape[i][10]=4;
	libShape[i][11]=0;
	libShape[i][12]=11;
	//Παραλληλόγραμμο
	i=6;
	libShape[i][0]=libShape[i-1][0]+BSize;
	libShape[i][1]=TopPanelHeight+20;
	libShape[i][2]=0;
	libShape[i][3]=0;
	libShape[i][4]=parseInt(BSize/Math.sqrt(2));
	libShape[i][5]=parseInt(BSize/Math.sqrt(2));
	libShape[i][6]=parseInt(BSize/Math.sqrt(2)+BSize*Math.sqrt(2));
	libShape[i][7]=parseInt(BSize/Math.sqrt(2));
	libShape[i][8]=parseInt(BSize*Math.sqrt(2));
	libShape[i][9]=0;
	libShape[i][10]=4;
	libShape[i][11]=0;
	libShape[i][12]=11;
}